#include <minigui.ch>

************************************************************************************************************************
////                                       REPORTES DE TABLAS
************************************************************************************************************************

************************
procedure grid_tablas(a)
************************
private xx,yy,dato_a_cargar
private _aCampos     as array                // Nombre de los campos para la tabla.
private _aLargoCampos     as array           // Largo de los campos para la tabla.
private _aContenidoCampos as array           // Contenido de los campos de la tabla.
private _aControles as array                 // Contiene el control a mostrar para cada columna del Grid
private reporte_tabla, filtrar
private nCsvPrint,nCantRegi

nCsvPrint := a
filtrar := 0
nCantRegi := 0

if nCsvPrint = 0
   return
endif
*------------------ Selecciono Archivo
*reporte_tabla := Getfile ( { {'dbf','*.dbf'} } , 'Seleccione un archivo para generar el reporte' , camino , .f. , .t. )
reporte_tabla := '_datadic'

* si no seleccione nada que cancele
if len(reporte_tabla) = 0
    return
endif


// Cargo los campos de la tabla ac ya que en abro_w_tabla al desplegar el Browse no muestra los campos
// ya que an no se cargaron en la matriz _aCampos

select 1
if netuse (reporte_tabla,'rpt_tbl',.f.,10) // no hago esto * camino+reporte_tabla * ya que reporte_tabla tiene
                                                      // el path incluido
     x := 0
     _aCampos := {}
     _aLargoCampos := {}

     wait window 'Cargando datos a la grilla ... espere por favor' NOWAIT
     cursorwait()

     for x = 1 to fcount()
           aadd(_aCampos,fieldname(x))
           aadd(_aLargoCampos,iif(DBFIELDINFO(3,x)<=10,100,200))
           *aadd(_aLargoCampos,100)
     next x
     abrio_tabla := 1
     go top

     WAIT CLEAR
     cursorarrow()
else
     msgstop('Imposible Abrir Base ' + reporte_tabla + ' en uso o inexistente','grid_tablas')
     return
endif

nCantRegi := reccount()
* close rpt_tbl
edito_reporte_tabla()

return

*****************************
procedure edito_reporte_tabla
*****************************

* Grid Column Controls Definitions
_aControles := {}
aCtrl_1 := { 'TEXTBOX'	,'CHARACTER'}
aCtrl_2 := { 'CHECKBOX' , 'Yes' , 'No' }
aCtrl_3 := {'TEXTBOX','NUMERIC'}
aCtrl_4 := {'DATEPICKER','UPDOWN'}

for x = 1 to fcount()
       do case
               case VALTYPE(fieldget(x)) = 'C'
                   aadd(_aControles,'aCtrl_1')
               case VALTYPE(fieldget(x)) = 'L'
                   aadd(_aControles,'aCtrl_2')
               case VALTYPE(fieldget(x)) = 'N'
                   aadd(_aControles,'aCtrl_3')
               case VALTYPE(fieldget(x)) = 'D'
                   aadd(_aControles,'aCtrl_4')
               otherwise
                   aadd(_aControles,'aCtrl_1')
       endcase
next x

define window form_abm_reporte;
    at 0,0;
    width getdesktopwidth();
    height getdesktopheight()-60;
    title "Reporte de la tabla <" + reporte_tabla + '>' ;
    modal;
    NOSIZE;
    NOSYSMENU;
    on init iif(abrio_tabla = 1,form_abm_reporte.STATUSBAR.ITEM(1) := " Registros: "+str(nCantRegi),form_abm_reporte.release)

    select rpt_tbl

    @ 50,20 grid grid_modi;
       WIDTH 980;
       HEIGHT 580;
       HEADERS _aCampos;
       WIDTHS _aLargoCampos;
       VALUE { 1 , 1 } ;
       COLUMNCONTROLS _aControles;
       ROWSOURCE "rpt_tbl" ;
       COLUMNFIELDS _aCampos

        DEFINE TOOLBAR ToolBar_Principal BUTTONSIZE 50,50
			BUTTON salir ;
			PICTURE 'salir.bmp' ;
			ACTION salir_reporte_tabla() TOOLTIP 'Salir de la Grilla y volver a ejecutar una nueva consulta'

			BUTTON excel ;
			PICTURE 'excel.bmp' ;
			ACTION To_Excel() TOOLTIP 'Exportar a Excel'

        END TOOLBAR

    define statusbar font "ms sans serif" SIZE 9
	  statusitem iif(abrio_tabla = 0," Registros: "," Registros: "+str(nCantRegi)) width 100
	  date width 80
	  clock width 80
	  keyboard width 82
    end statusbar

end window

center window form_abm_reporte
activate window form_abm_reporte

return

**********************
procedure borro_config
**********************
if MsgYesNo ( 'Borra Configuracin anterior ?' , 'Config.del reporte' ,.t. )
     if file("reports.cfg")
          ERASE ("reports.cfg")
     endif
endif
return

*****************************
procedure salir_reporte_tabla
*****************************
form_abm_reporte.release
return

************************************************************************************************************************
////                    FIN ---->     REPORTES DE TABLAS
************************************************************************************************************************
