#include "minigui.ch"

function main

	* Seteos de Clipper
	set date brit
	set century on
	set softseek off
	set delete on

	* Seteos de MiniGUI
	set language to spanish
	SET BROWSESYNC on
	set multiple off
	set navigation extended
	importa_sql_a_dbf()

return

**************************
function importa_sql_a_dbf
**************************
Public nValor

DEFINE WINDOW form_importa_sql_a_dbf;
	AT 0,0;
	WIDTH GetDesktopWidth()/2;
	HEIGHT GetDesktopHeight()/4;
        TITLE 'Extracin de datos de MS-SQL a DBF ( By Fernando Chirico )';
        ICON "icono" ;
	MAIN;
        on init (carga_datos(),grid_tablas(nValor))

        DEFINE IMAGE Fondo
               col 5
               row 35
               WIDTH GetDesktopWidth()/2.07
               HEIGHT GetDesktopHeight()/6.5
               PICTURE	'fondo.jpg'
               STRETCH	.t.
         END IMAGE


        DEFINE TOOLBAR ToolBar_sqltodbf;
                        BUTTONSIZE 20,25;
			IMAGESIZE 20,25

                        BUTTON ejecutar ;
			PICTURE 'ejecutar.bmp' ;
			ACTION (carga_datos(),grid_tablas(nValor)) TOOLTIP 'Ejecutar una consulta nuevamente'

			BUTTON salir1 ;
			PICTURE 'salir1.bmp' ;
			ACTION form_importa_sql_a_dbf.release TOOLTIP 'Salir de la aplicacin'
        END TOOLBAR


END WINDOW

	CENTER WINDOW form_importa_sql_a_dbf

	ACTIVATE WINDOW form_importa_sql_a_dbf

RETURN


*********************
procedure carga_datos
*********************
Local cdirlocal,aResults,cSQL,cUsr,cPass,cServer,cBD,cMsgError,cOpen,prgactsvr
public dsFunctions, cConStr,registro

cdirlocal := 'd:\Prueba_HMG_SQL\Prueba03\'
cSQL :='Select * from'
cUsr := 'scdconsulta'
cPass := ''
cServer := 'SERV07-SCD'
cBD := 'SCD'
aResults := {}

CURSORWAIT()
        *into dbf &CDIRLOCAL\_temp
        *sql="Select com_id, com_erp_id, com_descripcion from componente where com_id <21"
        *sql="Select * from operario"
        *sql="Select com_id, com_erp_id, com_descripcion from componente"
        aResults := InputWindow("Inicio de sesin",;
                   { 'Servidor:','Base de Datos:','Usuario:','Password:','SQL:' },;
                   {cServer,cBD,cUsr,cPass,cSQL},;
                   {30,30,30,20,100})
        If aResults[1] != Nil
             cServer := AllTrim(aResults [1])
             cBD := AllTrim(aResults [2])
             cUsr := AllTrim(aResults [3])
             cPass := AllTrim(aResults [4])
             cSQL := AllTrim(aResults [5])
             sql := cSQL
        else
             msgbox('Sentencia SQL no vlida','Error SQL')
             form_importa_sql_a_dbf.release
        endif

        *cConStr := "DSN=DNS ODBC para SCD;UID=scdconsulta;PWD=C0nsulta18900"
        *cConStr := "DSN=DNS ODBC para SCD;UID=" + cUsr + ";PWD=" + cPass

        *Driver={SQL Native Client};Server=myServerAddress;Database=myDataBase; Uid=myUsername;Pwd=myPassword;
        *cConStr := "Driver={SQL Native Client};Server=SERV07-SCD;Database=SCD;UID=scdconsulta;PWD=C0nsulta18900"
        cConStr := "Driver={SQL Native Client};Server=" + cServer + ";Database=" + cBD + ";UID=" + cUsr + ";PWD=" + cPass


	dsFunctions := TODBC():New( cConStr )
	cMsgError := dsfunctions:SQLErrorMessage()
        if substr(cMsgError,1,13) = 'Error IM008 -'
	     msgbox('Error en alguno de los datos de INICIO DE SESION','Error: TODBC()')
	     close all
	     nValor := 0
	     return
	endif

        WAIT WINDOW "Seteo sentencia SQL" NOWAIT
        dsfunctions:SetSQL(sql)
        WAIT CLEAR

        WAIT WINDOW "Ejecutando sentencia SQL" NOWAIT
        dsfunctions:open()
        WAIT CLEAR

        dsfunctions:first()

        create _temp
        WAIT WINDOW "Creando estructura a DBF" NOWAIT
        genero_estructura()
        WAIT CLEAR
        create _datadic from _temp
        *run del _temp.dbf
        prgactsvr := 'del _temp.dbf'
        SHELLEXECUTE(0,"OPEN",prgactsvr,,,'SW_MAXIMIZE')
        registro := 0
        
        WAIT WINDOW "Pasando Datos SQL a DBF" NOWAIT
        CURSORWAIT()
        use _datadic
        do while .not. dsfunctions:eof()
                 registro := registro + 1
                 grabo_datos()
                 dsfunctions:skip()
        enddo
        WAIT CLEAR

        dsfunctions:close()

        dsFunctions:destroy()

CURSORARROW()

nValor := 1

return 

***************************
procedure genero_estructura
***************************
Local i
Private cTipoDato

cTipoDato := ''

FOR i := 1 TO len( dsFunctions:Fields )
         *msgbox(padl(dsfunctions:Fields[i]:fieldname,30,0),'campo')
         *msgbox(padl(dsfunctions:Fields[i]:datatype,30,0),'tipo')
         *msgbox(padl(dsfunctions:Fields[i]:datasize,30,0),'size')
         *msgbox(padl(dsfunctions:Fields[i]:datadecs,30,0),'decimales')
         append blank
         replace _temp->field_name with dsFunctions:Fields[i]:FieldName
         replace _temp->field_type with cTipoDato(dsfunctions:Fields[i]:datatype)
         replace _temp->field_len with dsfunctions:Fields[i]:datasize
         replace _temp->field_dec with dsfunctions:Fields[i]:datadecs

NEXT

* Para controlar en que CAMPO corta la importacin
*append blank
*replace _temp->field_name with '_flagsys'
*replace _temp->field_type with 'N'
*replace _temp->field_len with 1
*replace _temp->field_dec with 0

return

*********************
function cTipoDato(a)
*********************
Local nTypeData

nTypeData := 0
nTypeData := a

do case
       case  nTypeData = 4
            return 'N'
       case  nTypeData = -5
            *return 'N' // es lo que corresponde, pero no se porque la clase TODBC trae el contenido del campo como CARACTER,
                       //  ( por eso lo grabo como 'C' ) el tipo de dato lo trae bien es decir como 'N'
            return 'C'
       case  nTypeData = 3
            return 'N'
       case  nTypeData = 12
            return 'C'
       case  nTypeData = -9
            return 'C'
       case  nTypeData = 1
            return 'C'
       case  nTypeData = 11
            return 'D'
       case  nTypeData = -7
            return 'L'
       case  nTypeData = 2
            return 'N'
       case  nTypeData = 6
            return 'N'

       otherwise
            msgbox(padl(nTypeData,3,0),'Otherwise: tipo')
            return 'C'
endcase

return

*********************
procedure grabo_datos
*********************
Local i

select _datadic
append blank

FOR i := 1 TO len( dsFunctions:Fields )
         *msgbox(padl(dsfunctions:Fields[i]:fieldname,30,0),'campo')
         *msgbox(padl(dsfunctions:Fields[i]:datatype,30,0),'tipo')
         *msgbox(padl(dsfunctions:Fields[i]:datasize,30,0),'size')
         *msgbox(padl(dsfunctions:Fields[i]:datadecs,30,0),'decimales')
         *msgbox(padl(dsFunctions:Fields[i]:value,30,0),'value')
         *msgbox(valtype(dsFunctions:Fields[i]:value),'ValType')
         replace &('_datadic->' + FieldName(i)) with  dsFunctions:Fields[i]:value
NEXT

return


**************************************
* Funciones para el manejo del Mouse *
**************************************
#pragma BEGINDUMP

#include <windows.h>
#include <winuser.h>
#include "hbapi.h"

HB_FUNC( LOADCURSOR )
{
   HINSTANCE hInstance    = (HINSTANCE) hb_parnl(1);  // handle to a
   LPCTSTR   lpCursorName = (LPCTSTR)   hb_parc(2);   // name string

   hb_retnl( (long) LoadCursor( hInstance, lpCursorName ) );
}

HB_FUNC( CURSORARROW )
{
    hb_retnl( (long) SetCursor( LoadCursor( 0, IDC_ARROW ) ) );
}

HB_FUNC( CURSORWAIT )
{
    hb_retnl( (long) SetCursor( LoadCursor( 0, IDC_WAIT ) ) );
}

HB_FUNC( CURSORHAND )
{
    hb_retnl( (long) SetCursor( LoadCursor( 0, IDC_NO ) ) );
}

#pragma ENDDUMP

********************************************
* FIN - Funciones para el manejo del Mouse *
********************************************

